/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ActionSchemas type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActionSchemas{}

// ActionSchemas struct for ActionSchemas
type ActionSchemas struct {
	// JsonSchema with action configuration data
	Input map[string]interface{} `json:"input"`
	// JsonSchema with action output data
	Output map[string]interface{} `json:"output,omitempty"`
}

// NewActionSchemas instantiates a new ActionSchemas object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActionSchemas(input map[string]interface{}) *ActionSchemas {
	this := ActionSchemas{}
	this.Input = input
	return &this
}

// NewActionSchemasWithDefaults instantiates a new ActionSchemas object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActionSchemasWithDefaults() *ActionSchemas {
	this := ActionSchemas{}
	return &this
}

// GetInput returns the Input field value
func (o *ActionSchemas) GetInput() map[string]interface{} {
	if o == nil {
		var ret map[string]interface{}
		return ret
	}

	return o.Input
}

// GetInputOk returns a tuple with the Input field value
// and a boolean to check if the value has been set.
func (o *ActionSchemas) GetInputOk() (map[string]interface{}, bool) {
	if o == nil {
		return map[string]interface{}{}, false
	}
	return o.Input, true
}

// SetInput sets field value
func (o *ActionSchemas) SetInput(v map[string]interface{}) {
	o.Input = v
}

// GetOutput returns the Output field value if set, zero value otherwise.
func (o *ActionSchemas) GetOutput() map[string]interface{} {
	if o == nil || IsNil(o.Output) {
		var ret map[string]interface{}
		return ret
	}
	return o.Output
}

// GetOutputOk returns a tuple with the Output field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActionSchemas) GetOutputOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Output) {
		return map[string]interface{}{}, false
	}
	return o.Output, true
}

// HasOutput returns a boolean if a field has been set.
func (o *ActionSchemas) HasOutput() bool {
	if o != nil && !IsNil(o.Output) {
		return true
	}

	return false
}

// SetOutput gets a reference to the given map[string]interface{} and assigns it to the Output field.
func (o *ActionSchemas) SetOutput(v map[string]interface{}) {
	o.Output = v
}

func (o ActionSchemas) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActionSchemas) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["input"] = o.Input
	if !IsNil(o.Output) {
		toSerialize["output"] = o.Output
	}
	return toSerialize, nil
}

type NullableActionSchemas struct {
	value *ActionSchemas
	isSet bool
}

func (v NullableActionSchemas) Get() *ActionSchemas {
	return v.value
}

func (v *NullableActionSchemas) Set(val *ActionSchemas) {
	v.value = val
	v.isSet = true
}

func (v NullableActionSchemas) IsSet() bool {
	return v.isSet
}

func (v *NullableActionSchemas) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActionSchemas(val *ActionSchemas) *NullableActionSchemas {
	return &NullableActionSchemas{value: val, isSet: true}
}

func (v NullableActionSchemas) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActionSchemas) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


